#include "Header.h"
#include "List.h"
#include "Symbols.h"
#include "Io.h"
#include "Unify.h"
#include "Ac.h"
#include "Discrim.h"
#include "Fpa.h"
#include "Clause.h"
#include "List.h"
#include "Paramod.h"
#include "Demod.h"
#include "Eqp.h"

#include <unistd.h>  /* for gethostname() */

/*************
 *
 *    void print_banner(argc, argv)
 *
 *************/

static void print_banner(int argc, char **argv)
{
    int i;
    char host[64];

    if (gethostname(host, 64) != 0)
	strcpy(host, "???");

    printf("----- EQP 0.9, June 1996 -----\nThe job began on %s, %s", host, get_time());

    printf("The command was \"");
    for(i = 0; i < argc; i++)
        printf("%s%s", argv[i], (i < argc-1 ? " " : ""));
    printf("\".\n\n");
    
}  /* print_banner */

#include "Pindex.h"

void temp_insert_random(Pair_index_ptr idx)
{
    static int id;
    int wt;
    Clause_ptr c;
    
    c = get_clause();
    wt = rand() % idx->n;
    c->weight = wt;
    c->id = ++id;
    insert_pair_index(c, wt, idx);
}  /* temp_insert_random */

/*************
 *
 *   temp_test()
 *
 *************/

void temp_test(int argc, char **argv)
{
    Clause_ptr c1, c2;
    Pair_index_ptr idx;
    int i, wt, sum, k, j;
    int size, n, seed, extra, freq;

    if (argc != 6) {
	printf("NEED 5 ARGS: index-size  num-clauses  extra freq seed.\n");
	exit(1);
	}
    size = atoi(argv[1]);
    n = atoi(argv[2]);
    extra = atoi(argv[3]);
    freq = atoi(argv[4]);
    seed = atoi(argv[5]);

    printf("%d %d %d %d %d\n", size, n, extra, freq, seed);

    srand(seed);

    idx = init_pair_index(size);

    for (i = 1; i <= n; i++)
	temp_insert_random(idx);
#if 0
    p_pair_index(idx); fflush(stdout);
#endif

    retrieve_pair(idx, &c1, &c2);
    i = 0; sum = 0; k = 0;
    while (c1) {
	i++;
	if (i % freq == 0 && k < extra)
	    { temp_insert_random(idx); k++; }
#if 0
	if (sum != c1->weight + c2->weight) {
	    printf("\n");
	    sum = c1->weight + c2->weight;
	    }
	printf(" (%d,%d)", c1->id, c2->id);
	fflush(stdout);
#endif
	retrieve_pair(idx, &c1, &c2);
	}
    printf("\n%d extra clauses inserted.\n", k);
    printf("\n%d pairs retrieved.\n", i);

    j = ((n+k)*(n+k)+(n+k))/2;
    if (i != j)
	printf("ERROR, %d should be retrieved.\n", j);

#if 0
    p_pair_index(idx);
#endif

    exit(0);

}  /* temp_test */

/*************
 *
 *    main
 *
 *************/

int main(int argc, char **argv)
{
    int rc;

    print_banner(argc, argv);
    init();

/*    temp_test(argc, argv);  */

    read_preamble();  /* up to "end_of_commands". */

    if (Stats[INPUT_ERRORS] != 0) {
        fprintf(stderr, "\nInput errors were found.\007\n\n");
        printf("Input errors were found.\n");
        print_options(stdout);
        exit(INPUT_ERROR_EXIT);
        }
    else {
	rc = eq_prover();
        output_stats(stdout);
	exit(rc);
	}
}  /* main */

